/* csmthresp.c                            -tab July 2018 */

#include "ctab.h"
#include "cmisc.h"
#include "fstuff.h"
#include "cpgplot.h"
#include "cpg-util.h"
#include "cufio.h"


extern int csmthresp_apply( char aafile[], char bbfile[] );


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  csmthresp: Smoothing a spectral image.
*/
int main(int argc, char *argv[])
{
/**/
char arg[500][100];
char aafile[100];
char bbfile[100];
int narg;
/**/   

/* Copy arguments. */
cargcopy(argv, argc, &narg, arg);

/* Syntax. */
if (narg < 1) {
  printf("Syntax: csmthresp (Response FITS file from 'star2resp') (output FITS file)\n");
  printf("\n");  
  printf("  Example: csmthresp Resp-242.fits Resp-242-smooth.fits \n");  
  printf("\n");  
  exit(0);
}

/* Set files. */
strcpy(aafile,arg[1]);
cAddFitsExt(aafile);
if (narg > 1) {
  strcpy(bbfile,arg[2]);
  cAddFitsExt(bbfile);
} else {
  strcpy(bbfile,"none");
}

/* Smooth and write out new file */
if ( csmthresp_apply( aafile, bbfile ) != 1) {
  fprintf(stderr,"ERROR: csmthresp: Smoothing data.\n");
  return(0);
}

return(0);
}
